// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: customers.sql

package db

import (
	"context"
)

const createCustomer = `-- name: CreateCustomer :one
INSERT INTO customers (
    name,
    patient_id,
    user_id,
    account_id
) VALUES (
    $1, $2, $3, $4
) RETURNING id, name, patient_id, user_id, account_id
`

type CreateCustomerParams struct {
	Name      string `json:"name"`
	PatientID int64  `json:"patient_id"`
	UserID    int64  `json:"user_id"`
	AccountID int64  `json:"account_id"`
}

func (q *Queries) CreateCustomer(ctx context.Context, arg CreateCustomerParams) (Customers, error) {
	row := q.db.QueryRowContext(ctx, createCustomer,
		arg.Name,
		arg.PatientID,
		arg.UserID,
		arg.AccountID,
	)
	var i Customers
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.PatientID,
		&i.UserID,
		&i.AccountID,
	)
	return i, err
}

const deleteCustomer = `-- name: DeleteCustomer :exec
DELETE FROM customers WHERE id = $1
`

func (q *Queries) DeleteCustomer(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deleteCustomer, id)
	return err
}

const getCustomer = `-- name: GetCustomer :one
SELECT id, name, patient_id, user_id, account_id FROM customers
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetCustomer(ctx context.Context, id int64) (Customers, error) {
	row := q.db.QueryRowContext(ctx, getCustomer, id)
	var i Customers
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.PatientID,
		&i.UserID,
		&i.AccountID,
	)
	return i, err
}

const listCustomers = `-- name: ListCustomers :many
SELECT id, name, patient_id, user_id, account_id FROM customers
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListCustomersParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListCustomers(ctx context.Context, arg ListCustomersParams) ([]Customers, error) {
	rows, err := q.db.QueryContext(ctx, listCustomers, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Customers
	for rows.Next() {
		var i Customers
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.PatientID,
			&i.UserID,
			&i.AccountID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateCustomer = `-- name: UpdateCustomer :exec
UPDATE customers 
SET name = $2
WHERE id = $1
`

type UpdateCustomerParams struct {
	ID   int64  `json:"id"`
	Name string `json:"name"`
}

func (q *Queries) UpdateCustomer(ctx context.Context, arg UpdateCustomerParams) error {
	_, err := q.db.ExecContext(ctx, updateCustomer, arg.ID, arg.Name)
	return err
}
